

<!DOCTYPE html>

<html lang="ja">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.15.13. math_abs &#8212; Groonga v10.1.1-31-g1e46ba6ドキュメント</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    <script src="../../_static/translations.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="索引" href="../../genindex.html" />
    <link rel="search" title="検索" href="../../search.html" />
    <link rel="next" title="7.15.14. now" href="now.html" />
    <link rel="prev" title="7.15.12. in_values" href="in_values.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">オープンソースのカラムストア機能付き全文検索エンジン</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../en/html/reference/functions/math_abs.html">English</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             accesskey="I">索引</a></li>
        <li class="right" >
          <a href="now.html" title="7.15.14. now"
             accesskey="N">次へ</a> |</li>
        <li class="right" >
          <a href="in_values.html" title="7.15.12. in_values"
             accesskey="P">前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" accesskey="U"><span class="section-number">7.15. </span>関数</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.13. </span><code class="docutils literal notranslate"><span class="pre">math_abs</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="math-abs">
<h1><span class="section-number">7.15.13. </span><code class="docutils literal notranslate"><span class="pre">math_abs</span></code><a class="headerlink" href="#math-abs" title="このヘッドラインへのパーマリンク">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.15.13.1. </span>概要<a class="headerlink" href="#summary" title="このヘッドラインへのパーマリンク">¶</a></h2>
<div class="versionadded">
<p><span class="versionmodified added">バージョン 7.0.4 で追加.</span></p>
</div>
<p><code class="docutils literal notranslate"><span class="pre">math_abs</span></code> は絶対値を返します。</p>
<p>この関数を有効にするには、以下のコマンドで <code class="docutils literal notranslate"><span class="pre">functions/math</span></code> プラグインを登録します:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>plugin_register functions/math
</pre></div>
</div>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.15.13.2. </span>構文<a class="headerlink" href="#syntax" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">math_abs</span></code> は引数を一つだけとります。 それは <code class="docutils literal notranslate"><span class="pre">target</span></code> です。</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>math_abs(target)
</pre></div>
</div>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.15.13.3. </span>使い方<a class="headerlink" href="#usage" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>使い方を示すために使うスキーマ定義とサンプルデータは以下の通りです。</p>
<p>サンプルスキーマ:</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Shops TABLE_HASH_KEY ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Shops from_station COLUMN_SCALAR Int32
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Shops from_office COLUMN_SCALAR Int32
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>サンプルデータ:</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>load --table Shops
[
{&quot;_key&quot;: &quot;Coffee Shop&quot;,         &quot;from_station&quot;:  50},
{&quot;_key&quot;: &quot;Donut &amp; Coffee Shop&quot;, &quot;from_station&quot;: 400},
{&quot;_key&quot;: &quot;Cake &amp; Coffee Shop&quot;,  &quot;from_station&quot;: 200}
]
# [[0, 1337566253.89858, 0.000355720520019531], 3]
</pre></div>
</div>
<p>職場から最も近いお店を返す <code class="docutils literal notranslate"><span class="pre">math_abs</span></code> 関数の簡単な例はこちらです。</p>
<p>最も近いお店を探すためには距離を計算してあげる必要があります。もし職場が駅から250mのところにあるとしたら、 <code class="docutils literal notranslate"><span class="pre">math_abs(250</span> <span class="pre">-</span> <span class="pre">from_station)</span></code> で距離を計算できます。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Shops --filter true --output_columns &#39;_key, from_office&#39; --scorer &#39;from_office = math_abs(250 - from_station)&#39; --sort_keys from_office
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         3
#       ],
#       [
#         [
#           &quot;_key&quot;,
#           &quot;ShortText&quot;
#         ],
#         [
#           &quot;from_office&quot;,
#           &quot;Int32&quot;
#         ]
#       ],
#       [
#         &quot;Cake &amp; Coffee Shop&quot;,
#         50
#       ],
#       [
#         &quot;Donut &amp; Coffee Shop&quot;,
#         150
#       ],
#       [
#         &quot;Coffee Shop&quot;,
#         200
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">--sort_keys</span> <span class="pre">from_office</span></code> を指定することで、職場から近いお店を昇順で表示できます。</p>
</div>
<div class="section" id="parameters">
<h2><span class="section-number">7.15.13.4. </span>引数<a class="headerlink" href="#parameters" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>必須の引数は1つです。</p>
<div class="section" id="target">
<h3><span class="section-number">7.15.13.4.1. </span><code class="docutils literal notranslate"><span class="pre">target</span></code><a class="headerlink" href="#target" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p><code class="docutils literal notranslate"><span class="pre">select</span></code> 対象の <code class="docutils literal notranslate"><span class="pre">table</span></code> に指定されたテーブルのカラムを指定します。</p>
</div>
</div>
<div class="section" id="return-value">
<h2><span class="section-number">7.15.13.5. </span>戻り値<a class="headerlink" href="#return-value" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">math_abs</span></code> は対象の絶対値を返します。</p>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">目次</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.15.13. <code class="docutils literal notranslate"><span class="pre">math_abs</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.15.13.1. 概要</a></li>
<li><a class="reference internal" href="#syntax">7.15.13.2. 構文</a></li>
<li><a class="reference internal" href="#usage">7.15.13.3. 使い方</a></li>
<li><a class="reference internal" href="#parameters">7.15.13.4. 引数</a><ul>
<li><a class="reference internal" href="#target">7.15.13.4.1. <code class="docutils literal notranslate"><span class="pre">target</span></code></a></li>
</ul>
</li>
<li><a class="reference internal" href="#return-value">7.15.13.5. 戻り値</a></li>
</ul>
</li>
</ul>

  <h4>前のトピックへ</h4>
  <p class="topless"><a href="in_values.html"
                        title="前の章へ"><span class="section-number">7.15.12. </span><code class="docutils literal notranslate"><span class="pre">in_values</span></code></a></p>
  <h4>次のトピックへ</h4>
  <p class="topless"><a href="now.html"
                        title="次の章へ"><span class="section-number">7.15.14. </span>now</a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">クイック検索</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="検索" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             >索引</a></li>
        <li class="right" >
          <a href="now.html" title="7.15.14. now"
             >次へ</a> |</li>
        <li class="right" >
          <a href="in_values.html" title="7.15.12. in_values"
             >前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" ><span class="section-number">7.15. </span>関数</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.13. </span><code class="docutils literal notranslate"><span class="pre">math_abs</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>